import { EntityInventoryComponent, world } from "@minecraft/server";
import { ModalFormData } from "@minecraft/server-ui";
import { checking, checkingForCpDoor } from "./button";
function enter(player, index, block, permutation) {
    const modalform = new ModalFormData().title("通行码访问").submitButton('确定');
    const loc = block.location;
    const locOfOnPlacedBlock = {
        x: block.location.x,
        y: block.location.y - 5,
        z: block.location.z
    };
    const startLoc = {
        x: loc.x + 1,
        y: loc.y,
        z: loc.z + 1
    };
    const endLoc = {
        x: loc.x - 1,
        y: loc.y - 1,
        z: loc.z - 1
    };
    const startLoc2 = {
        x: loc.x + 2,
        y: loc.y,
        z: loc.z + 2
    };
    const endLoc2 = {
        x: loc.x - 2,
        y: loc.y - 1,
        z: loc.z - 2
    };
    const code = world.getDynamicProperty(index);
    modalform.textField('请输入访问码', '于此输入访问码');
    modalform
        .show(player)
        .then((formData) => {
        if (formData.formValues === undefined) {
            return;
        }
        else {
            if (code == formData.formValues[0]) {
                player.runCommand('title @s actionbar 访问码正确，允许访问');
                block.setPermutation(permutation.withState('is:interacted', true));
                checking(block.dimension, startLoc, endLoc, true);
                checkingForCpDoor(block.dimension, startLoc2, endLoc2);
                block.dimension.setBlockType(locOfOnPlacedBlock, 'minecraft:redstone_block');
                block.dimension.playSound('check1', block.location);
            }
            else {
                player.runCommand('title @s actionbar 访问码错误，拒绝访问');
                block.dimension.playSound('check2', block.location);
            }
        }
    });
}
//输入访问码
function setCode(player, index) {
    const modalform = new ModalFormData().title("通行码门禁控制系统").submitButton('确定');
    const code = world.getDynamicProperty(index);
    modalform.textField('请设置访问码', '于此设置访问码（位数不限）', code);
    modalform
        .show(player)
        .then((formData) => {
        if (formData.formValues === undefined) {
            return;
        }
        if (typeof formData.formValues[0] !== 'string') {
            return;
        }
        else {
            world.setDynamicProperty(index, formData.formValues[0]);
            player.runCommand('title @s actionbar 成功设置访问码：' + formData.formValues[0]);
        }
    });
}
//设置访问码等
export class passcodeButton {
    onPlayerInteract(arg) {
        const player = arg.player;
        const block = arg.block;
        const perm = block.permutation;
        const location = block.location;
        const index = 'x' + location.x + 'y' + location.y + 'z' + location.z;
        const isi = perm.getState('is:interacted');
        if (isi === undefined || typeof isi !== "boolean") {
            return;
        }
        if (typeof player === 'undefined') {
            return;
        }
        const inventory = player.getComponent(EntityInventoryComponent.componentId);
        if (inventory === undefined) {
            return false;
        }
        const selectedItem = inventory.container?.getItem(player.selectedSlotIndex);
        if (selectedItem && selectedItem.typeId === "tool:change" && player.getGameMode() === 'creative') {
            setCode(player, index);
        }
        else {
            enter(player, index, block, perm);
        }
    }
    onPlace(arg) {
        const location = arg.block.location;
        const index = 'x' + location.x + 'y' + location.y + 'z' + location.z;
        world.setDynamicProperty(index, '0000');
    }
}
export class pcReset {
    onTick(arg) {
        const block = arg.block;
        const dimension = arg.dimension;
        const perm = block.permutation;
        const isi = perm.getState('is:interacted');
        if (isi === undefined || isi == false || typeof isi !== "boolean") {
            return;
        }
        const loc = block.location;
        const locOfOnPlacedBlock = {
            x: loc.x,
            y: loc.y - 5,
            z: loc.z
        };
        if (isi === true) {
            block.setPermutation(perm.withState('is:interacted', false));
            dimension.setBlockType(locOfOnPlacedBlock, 'minecraft:air');
        }
    }
}
