import { openDoor, closeDoor } from "./button";
import { system } from "@minecraft/server";
export class signalBlock {
    onPlace(arg) {
        const dimension = arg.block.dimension;
        const loc = arg.block.location;
        const block = arg.block.above(2);
        if (block === undefined || typeof block === undefined) {
            return;
        }
        const perm = block.permutation;
        const doorState = perm.getState('id:door');
        const upperBlock = block.above(1);
        if (doorState === 1) {
            openDoor(block, true);
            if (upperBlock != undefined && typeof upperBlock != undefined) {
                openDoor(upperBlock, true);
            }
        }
        else if (doorState === 16) {
            closeDoor(block, true);
            if (upperBlock != undefined && typeof upperBlock != undefined) {
                closeDoor(upperBlock, true);
            }
        }
        else if (block.hasTag('hcz_door') && doorState === 15) {
            closeDoor(block, true);
            if (upperBlock != undefined && typeof upperBlock != undefined) {
                closeDoor(upperBlock, true);
            }
        }
        system.runTimeout(() => {
            if (dimension.getBlock(loc)?.hasTag('signalBlock')) {
                dimension.setBlockType(loc, 'minecraft:air');
            }
        }, 10);
    }
}
